/* Every bit below is copyrighted by Corvineum.
I give no permission to modify , redistribute,
or for the use of reverse engineering
any amount of code without a written permission
by the author (Corvineum)*/

const proconpvPrefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("procon.");
var whiteList_regex = getWhiteListRegex();
var reason = "";

window.getBrowser().addEventListener("DOMTitleChanged", onTitleChanged, true);
window.getBrowser().addEventListener("DOMContentLoaded", onContentChanged, true);

var listener = {
   observe : function(aSubject, aTopic, aData) {
      if (aTopic != 'http-on-modify-request') return;
      aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
      var a = aSubject.loadFlags;
      switch(a) {
         case 2686976 : break;
         case 2687232 : break;
         case 2689024 : break;
         default : return;
         }
		
	  if (proconpvPrefBranch.getBoolPref("enableWhiteList")){
	  whiteList_regex = getWhiteListRegex();
	  if(whiteList_regex.test(aSubject.URI.spec)){
			return;
		}
	  }

      if(proconpvPrefBranch.getBoolPref("bat")){
            var webNav = aSubject.notificationCallbacks.getInterface(Components.interfaces.nsIWebNavigation);
            aSubject.loadFlags = Components.interfaces.nsICachingChannel.LOAD_ONLY_FROM_CACHE;
            aSubject.cancel(Components.results.NS_ERROR_FAILURE);
            remove_content(webNav, 1);
			return;
        }
			
      var acting = proconpvPrefBranch.getIntPref("action");
      switch(acting) {
         case 0 :  return;
         default : break;
         }
		 
      if(proconpvPrefBranch.getBoolPref("enabled")){
         if (checkLocation(aSubject.URI.spec)){
            var webNav = aSubject.notificationCallbacks.getInterface(Components.interfaces.nsIWebNavigation);
            aSubject.loadFlags = Components.interfaces.nsICachingChannel.LOAD_ONLY_FROM_CACHE;
            aSubject.cancel(Components.results.NS_ERROR_FAILURE);
            remove_content(webNav, 1);
            }
         }
      }
   , QueryInterface : function(aIID) {
      if (aIID.equals(Components.interfaces.nsISupports) || aIID.equals(Components.interfaces.nsIObserver)) return this;
      throw Components.results.NS_NOINTERFACE;
      }
   }
;
// Add and remove the observer
var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
observerService.addObserver(listener, "http-on-modify-request", false);
window.addEventListener("unload", function() {
   observerService.removeObserver(listener, "http-on-modify-request"); }
, false);

function checkLocation(location) {
  var url_reg = getUrlRegex();
  var scan = url_reg.exec(location);
  if(scan){
      reason = scan + " " + document.getElementById("procon-strings").getString("InURL");
      return true;
   }
   return false;
}
   
function onContentChanged(event) {
if(proconpvPrefBranch.getBoolPref("enabled")) {
   var valuemen = proconpvPrefBranch.getIntPref("action");
   switch(valuemen){
      case 1 : return;
      default : break;
      }
   var browser = event.target;
	  if (proconpvPrefBranch.getBoolPref("enableWhiteList") && whiteList_regex.test(browser.location.href)){
			return;
	  }
      if (checkin(browser)) {
         gBrowser.stop(browser);
         remove_content(browser, 2);
         return;
         }
      }
   return;
   }
   
function checkin(browser) {
   var word_reg = getWordRegex();
   var examineMeta = proconpvPrefBranch.getBoolPref("exMeta");
   var doc = browser;
   if(examineMeta) {
	 var ndx = 0;
	    while(doc.getElementsByTagName("meta")[ndx] != null){
		    var meta = doc.getElementsByTagName("meta")[ndx];	
			var Mcontent = meta.content;
			var metalower = meta.name.toLowerCase();
			var scan = "";
      if(metalower === "keywords"){
        scan = word_reg.exec(Mcontent);		
        if(scan){
          reason = scan + " " + document.getElementById("procon-strings").getString("InMeta");
          return true;
        }	
      }
      if(metalower === "description"){			
				scan = word_reg.exec(Mcontent);			
        if(scan){
          reason = scan + " " + document.getElementById("procon-strings").getString("InMeta");
          return true;
        }
      }
		    ndx++;
	    }
    }
	var examineBody = proconpvPrefBranch.getBoolPref("exBody");
   if(examineBody) {
	if (doc.getElementsByTagName("body").length > 0){
		var body = doc.getElementsByTagName("body")[0].innerHTML;
		var scanBody = word_reg.exec(body);
		if (scanBody) {
        reason = scanBody + " " + document.getElementById("procon-strings").getString("InBody");
        return true;
    }
	}    
   }
   
   return false;
}

function onTitleChanged(event) {
if(proconpvPrefBranch.getBoolPref("enabled")) {
 var examineTitle = proconpvPrefBranch.getBoolPref("exTitle");
   if(!(examineTitle)) {
   return;
    }
   var valuemen = proconpvPrefBranch.getIntPref("action");
   switch(valuemen) {
      case 1 : return;
      default : break;
      }
   var doc = event.originalTarget;
   doc = doc.defaultView.top.document;
   var browser = gBrowser.getBrowserForDocument(doc);
	  if (proconpvPrefBranch.getBoolPref("enableWhiteList") && whiteList_regex.test(browser.currentURI.spec)){
		return;
	  }
      var titlename = browser.contentTitle;
      var word_reg = getWordRegex();
      var scanTitle = word_reg.exec(titlename);
		if (scanTitle) {
        reason = scanTitle + " " + document.getElementById("procon-strings").getString("InTitle");
        browser.stop();
        remove_content(browser, 3);
        return;
    }
      }
   return;
}

function getWordRegex() {
var wordList = proconpvPrefBranch.getComplexValue("wordregex", Components.interfaces.nsIPrefLocalizedString).data;
   if (!((wordList.charAt(wordList.length - 1) === '\n'))) {
      wordList = wordList.concat("\n");
    }
   var flw = [];
   var regUni = filterUni(wordList);
   flw = regUni.split(/\n+/);
   flw.pop();
   var flwString = "\\b" + flw.join("\\b|\\b") + "\\b";
   flwString = flwString.replace(/\\b\\UPROCON/g,"\\u");
   flwString = flwString.replace(/\\LPROCON\\UPROCON/g,"\\u");
   flwString = flwString.replace(/\\LPROCON\\b/g,"");
   flwString = flwString.replace(/\\UPROCON/g,"\\u");
   flwString = flwString.replace(/\\LPROCON/g,"");
   flwString = flwString.replace(/\s/g,"\\s");
   var flwreg = new RegExp(flwString, "i");
   return flwreg;
}
function getUrlRegex() {
var wordList = proconpvPrefBranch.getComplexValue("urlregex", Components.interfaces.nsIPrefLocalizedString).data;
   if (!((wordList.charAt(wordList.length - 1) === '\n'))) {
      wordList = wordList.concat("\n");
    }
   var flw = [];
   flw = wordList.split(/\s+/);
   flw.pop();
   var flwString = flw.join("|");
   var flwreg = new RegExp(flwString, "i");
   return flwreg;
}
function getWhiteListRegex() {
   var whiteList = proconpvPrefBranch.getComplexValue("whiteList", Components.interfaces.nsIPrefLocalizedString).data;
   if (!((whiteList.charAt(whiteList.length - 1) === '\n'))) {
      whiteList = whiteList.concat("\n");
    }
   if(!((trim(whiteList) === '\n' || trim(whiteList) === ''))) {
      var flw = [];
      flw = whiteList.split(/\s+/);
      flw.pop();
      var flwString = flw.join("|");
      var flwreg = new RegExp(flwString, "i");
      return flwreg;
      }
   else {
      var flw = [];
      var flwString = flw.join("");
      var flwreg = new RegExp(flwString, "i");
      return flwreg;
      }
}
function filterUni(string) {
   var hexVal;
   for(var i = 0; i < string.length; i++) {
      if(string.charCodeAt(i) > 127) {
         hexVal = Number(string.charCodeAt(i)).toString(16);
         string = string.replace(new RegExp(string.charAt(i), "g"), "\\UPROCON" + ("000" + hexVal).match(/.{4}$/)[0] + "\\LPROCON");
         }
      }
   return string;
   }
function filterWords(event) {
  if (proconpvPrefBranch.getBoolPref("filteron")){
      var wordList = proconpvPrefBranch.getComplexValue("wordlist", Components.interfaces.nsIPrefLocalizedString).data;
      if (!(wordList.charAt(wordList.length - 1) === '\n')){
         wordList = wordList.concat("\n");
       }
      var flw = [];
      var regtun = filterUni(wordList);
      flw = regtun.split(/\n+/);
      flw.pop();
      var flwString = "\\b" + flw.join("\\b|\\b") + "\\b";
      flwString = flwString.replace(/\\b\\UPROCON/g,"\\u");
      flwString = flwString.replace(/\\LPROCON\\UPROCON/g,"\\u");
      flwString = flwString.replace(/\\LPROCON\\b/g,"");
      flwString = flwString.replace(/\\UPROCON/g,"\\u");
      flwString = flwString.replace(/\\LPROCON/g,"");
      flwString = flwString.replace(/\s/g,"\\s");
      var flwreg = new RegExp(flwString, "i");
	  
	//Begin of external script  
	/*
		Author: MCE
		Significantly rewritten other replacement scripts to noticably improve performance and add pseudo-threading to gradually replace words on larger pages.
		Version: 1.0
		1.0 - First Release

		Competing scripts and extensions:
		* http://www.arantius.com/article/arantius/clean+language/
   
		Improvements Needed:
		* Filter HTML attributes (ALT, TITLE, TOOLTIP, etc)
		* Add an interface to manage the words by turning this into an extension.
	*/
	// Licensed for unlimited modification and redistribution as long as
	// this notice is kept intact.  
	
	var MillisecondsPauseBetweenBatches=3;
	var NodesPerBatch = 20;
	var ReplacementText = proconpvPrefBranch.getComplexValue("customCens", Components.interfaces.nsISupportsString).data;
	var i = 0;
	var st = new Date().valueOf();  //for performance testing	
	var doc1 = event.target;
	var els = doc1.evaluate('//text()', doc1, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	//document.title=doc1.title.replace(flwreg, ReplacementText);
	function CleanSome(){		
		var el;
		var newval="";
		var data = "";
		var loopCount = 0;
		while ((el=els.snapshotItem(i++)) && (loopCount <= NodesPerBatch)){
			data = el.data;
			newval = data.replace(flwreg, ReplacementText);
			if (newval.length != data.length ||  newval != data){
				el.data = newval;
			}
			loopCount++;
		}
		
		if (el != null){
			//more work left to do
			i--;
			GoNow(MillisecondsPauseBetweenBatches);
		}
		else{
			DoneNow();
		}
	}
	
	function DoneNow(){
		var et = new Date().valueOf();
	}

	function GoNow(WaitUntil){
		window.setTimeout(CleanSome, WaitUntil); 
	}
	//spin the initial "thread"
	GoNow(0);
	}
	//End of external script
}
function remove_content(doc, back) {
   switch(back) {
      case 2 : var a = doc.getElementsByTagName("body")[0];
	  a.setAttribute('style', 'display:none!important;');
      break;
      default : break;
      }
   var customs = proconpvPrefBranch.getBoolPref("pcust");
   if (customs) {
      var myurl = proconpvPrefBranch.getCharPref("psit");
      switch(back) {
         case 1 : doc.loadURI(myurl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
         break;
         default : var contentBrwsr = gBrowser.getBrowserForDocument(doc.defaultView.top.document);
		 contentBrwsr.loadURI(myurl);
         break;
         }
      }
   else {
     var shrtDesc;
     if(proconpvPrefBranch.getBoolPref("customWarn") && proconpvPrefBranch.prefHasUserValue("WarningMsg")){
          shrtDesc = proconpvPrefBranch.getComplexValue("WarningMsg", Components.interfaces.nsISupportsString).data;
     } else {
          shrtDesc = document.getElementById("procon-strings").getString("shrtDesc");
     }
     if(proconpvPrefBranch.getBoolPref("reason")){
       shrtDesc = shrtDesc + " [" + document.getElementById("procon-strings").getString("Foundreason") + ": " + reason + "]";
     }
     switch(back) {
         case 2 : var contentBrwsr = gBrowser.getBrowserForDocument(doc);
		 var notificationBox = gBrowser.getNotificationBox(contentBrwsr);
         break;
		 case 3 : var notificationBox = gBrowser.getNotificationBox(doc);
         break;
         default : var notificationBox = gBrowser.getNotificationBox();
         break;
         }
		 var buttons = [{
            label: document.getElementById("procon-strings").getString("butopt"),
            accessKey: null,
            popup: "ProconblockedSite",
            callback: null
          }];
      const priority = notificationBox.PRIORITY_WARNING_HIGH;
      notificationBox.appendNotification(shrtDesc, "website-blocked", "chrome://procon/skin/img/n.png", priority, buttons);
      }
   }
function continueMan() {
   proconpvPrefBranch.setBoolPref("authenticated", false);
   //check for password, and ask for it if found
   if ( proconpvPrefBranch.prefHasUserValue("password") ) {
	  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
		input = {value:""};
		check = {value:false};
		var title = document.getElementById("procon-strings").getString("askTitle");
		var description = document.getElementById("procon-strings").getString("askPassword");
		okorcancel = prompts.promptPassword(null, title, description, input, null, check);
		var password = proconpvPrefBranch.getCharPref("password");
	if( okorcancel && hex_md5(input.value)  === password){
	window.openDialog("chrome://procon/content/continue.xul", "editContinue", "chrome,titlebar,toolbar,centerscreen,modal");
   return;
		}else{
		prompts.alert(null, title, document.getElementById("procon-strings").getString("WrongpassMessage"));
		return;
	}
      }
	  window.openDialog("chrome://procon/content/continue.xul", "editContinue", "chrome,titlebar,toolbar,centerscreen,modal");
   return;
   }

function loadprocon(){
	if (!proconpvPrefBranch.prefHasUserValue("action")) {
      proconpvPrefBranch.setIntPref("action", 2);
	}
   var keshort = proconpvPrefBranch.getCharPref("shortcut");
   document.getElementById("key1").setAttribute('key', keshort);
}
function hideabout() {
   var location = window._content.location.href.toLowerCase();
   if(location === "about:config") {
      if(proconpvPrefBranch.getBoolPref("abl")) {
         window._content.location = "about:blank";
         }
      }
   if(location === "chrome://mozapps/content/extensions/extensions.xul") {
      if(proconpvPrefBranch.getBoolPref("addons")) {
         window._content.location = "about:blank";
         }
      }
   if(location.indexOf("chrome://procon/") != - 1) {
      window._content.location = "about:blank";
      }
   }
function setStatus() {
   var alStat = proconpvPrefBranch.getBoolPref("pstatus");
   var AllStatusGet = document.getElementById("procon-status");
   if (alStat) {
      AllStatusGet.setAttribute('hidden', false);
      var sprocon = document.getElementById("status-procon");
      var chl = proconpvPrefBranch.getBoolPref("enabled");
      if (chl) {
         var trustS = false;
         var location = window._content.location.href;
         if (proconpvPrefBranch.getBoolPref("enableWhiteList")){
			if (whiteList_regex.test(location)){
            trustS = true;
            }
		 }
         if(trustS) {
            sprocon.src = "chrome://procon/skin/img/t.png";
            var stat = document.getElementById("procon-strings").getString("statustrusted");
            sprocon.setAttribute('tooltiptext', stat);
            }
         else {
            sprocon.src = "chrome://procon/skin/img/n.png";
            var stat = document.getElementById("procon-strings").getString("statuson");
            sprocon.setAttribute('tooltiptext', stat);
            }
         }
      else {
         sprocon.src = "chrome://procon/skin/img/a.png";
         var stat = document.getElementById("procon-strings").getString("statusoff");
         sprocon.setAttribute('tooltiptext', stat);
         }
      }
   else {
      AllStatusGet.setAttribute('hidden', true);
      }
   return;
   }

//context menu
function blockWord() {
   var enable = proconpvPrefBranch.getBoolPref("enableRealTime");
   if (enable) {
      var doc1 = window.content.document;
      txt = '';
      getSelectedText(doc1);
      if(!((!txt || trim(txt) === ''))) {
         var k = false;
         k = confirm( document.getElementById("procon-strings").getString("ConfirmBlockWord") + " \"" + txt + "\"?");
         if(k) {
            addWord(txt);
            goTo(window.content.location.href);
            }
         }
      }
   }
function filterWord() {
   var enable = proconpvPrefBranch.getBoolPref("enableRealTimeFiltering");
   if (enable) {
      var doc1 = window.content.document;
      txt = '';
      getSelectedText(doc1);
      if(!((!txt || trim(txt) === ''))) {
         var k = false;
         k = confirm(document.getElementById("procon-strings").getString("ConfirmFilterWord") + " \"" + txt + "\"?");
         if(k) {
            addWordFilter(txt);
            goTo(window.content.location.href);
            }
         }
      }
   }
function blockUrl() {
   var enable = proconpvPrefBranch.getBoolPref("enableRealTime");
   if (enable) {
      var doc1 = window.content.document;
      url = '';
      getUrl(window.content.location.href);
      if(!((!url || trim(url) === ''))) {
         var k = false;
         k = confirm(document.getElementById("procon-strings").getString("ConfirmBlockUrl") + " \"" + url + "\"?");
         if(k) {
            addUrl(url);
            goTo(window.content.location.href);
            }
         }
      }
   }
function addToWhiteList() {
   var enable = proconpvPrefBranch.getBoolPref("enableRealTimeWhiteList");
   if (enable) {
      var doc1 = window.content.document;
      url = '';
      getUrl(window.content.location.href);
      if(!((!url || trim(url) === ''))) {
         var k = false;
         k = confirm(document.getElementById("procon-strings").getString("ConfirmAddWhitelist") + " \"" + url + "\"?");
         if(k) {
            whiteListUrl(url);
            //goTo(window.content.location.href);
            }
         }
      }
   }
function getUrl(str) {
   index = str.lastIndexOf("/");
   url = str.substring(0, index);
   }
function trim(str) {
   var i = 0, j = str.length - 1;
   while(str.charAt(i) === ' ') i++;
   while(str.charAt(j) === ' ') j--;
   j++;
   return str.substring(i, j);
   }
function getSelectedText(doc) {
   // get selected text
   txt = doc.getSelection();
   // if no selected text, check for
   if(!txt || txt === '') {
      txt = prompt( document.getElementById("procon-strings").getString("InsertText"), '');
      }
   }
function goTo(uri) {
   window.content.location.href = uri;
   }
function addWord(word) {
   var doc1 = window.content.document;
   wordregex = proconpvPrefBranch.getComplexValue("wordregex", Components.interfaces.nsIPrefLocalizedString).data;
   wordregex = wordregex + "\n" + word ;
   proconpvPrefBranch.setCharPref("wordregex", wordregex);
   }
function addWordFilter(word) {
   var doc1 = window.content.document;
   wordlist = proconpvPrefBranch.getComplexValue("wordlist", Components.interfaces.nsIPrefLocalizedString).data;
   wordlist = wordlist + "\n" + word;
   proconpvPrefBranch.setCharPref("wordlist", wordlist);
   }
function addUrl(url) {
   var doc1 = window.content.document;
   urlregex = proconpvPrefBranch.getComplexValue("urlregex", Components.interfaces.nsIPrefLocalizedString).data;
   urlregex = urlregex + "\n" + url;
   proconpvPrefBranch.setCharPref("urlregex", urlregex);
   }
function whiteListUrl(url) {
   var doc1 = window.content.document;
   whiteList = proconpvPrefBranch.getComplexValue("whiteList", Components.interfaces.nsIPrefLocalizedString).data;
   if(whiteList.length > 1) {
      if (!((whiteList.charAt(whiteList.length - 1) === '\n'))) {
         whiteList = whiteList.concat("\n");
         }
      }
   whiteList = whiteList + url + "\n";
   proconpvPrefBranch.setCharPref("whiteList", whiteList);
   }
//end context menu